/*	 {
		HDC hDC = (HDC) wParam;
		RECT ClientRect;
		HBRUSH hBrush, hOldBrush;
		HPEN hPen, hOldPen;

		// Begin the painting and gather client dimensions
		GetClientRect(hWnd, &ClientRect);

		// Create a brush and a pen.  Select them into the device context...
		hBrush = CreateSolidBrush(gp.Color[BACKGROUND]);
		hPen = CreatePen(PS_SOLID, 1, gp.Color[BACKGROUND]);
		hOldBrush = SelectObject(hDC, hBrush);
		hOldPen = SelectObject(hDC, hPen);

		// Draw the rectangle
		Rectangle(hDC, ClientRect.left, ClientRect.top, ClientRect.right,
					 ClientRect.bottom);

		// Unselect the objects and delete the brush and the pen
		SelectObject(hDC, hOldBrush);
		SelectObject(hDC, hOldPen);
		DeleteObject(hPen);
		DeleteObject(hBrush);
		return TRUE;
	 }*/

    //		LPLOGPALETTE lp;
//		HPALETTE hPal, hOldPal, hmemOldPal;
//		int lcv;
/*		lp = (LPLOGPALETTE) LocalAlloc(LPTR, sizeof(LOGPALETTE) + (TICK + 1) *
												 sizeof(PALETTEENTRY));
		for (lcv = ASYMPTOTE; lcv <= TICK; lcv++)
		{
		  lp->palPalEntry[lcv].peRed = GetRValue(gp.Color[lcv]);
		  lp->palPalEntry[lcv].peGreen = GetGValue(gp.Color[lcv]);
		  lp->palPalEntry[lcv].peBlue = GetBValue(gp.Color[lcv]);
		  lp->palPalEntry[lcv].peFlags = PC_NOCOLLAPSE;
		}
		lp->palVersion = 0x300;
		lp->palNumEntries = TICK + 1;
		hPal = CreatePalette(lp);
		LocalFree(LocalHandle(lp));
		hOldPal = SelectPalette(hDC, hPal, FALSE);
		hmemOldPal = SelectPalette(memDC, hPal, FALSE);
		RealizePalette(hDC);*/
//		SelectPalette(hDC, hOldPal, FALSE);
//		SelectPalette(memDC, hmemOldPal, FALSE);
//		DeleteObject(hPal);
		hBitmap = WinGCreateBitmap(ClientRect.right, ClientRect.bottom, 1, 8, NULL);


void DrawGraph(HDC hDC, RECT ClientRect, GridProperties *g)
{
  int ClientPlots[33];
  COLORREF OldBkColor;
  POINT Orgin;
  HPEN hPen, hOldPen;
  HBRUSH hBrush, hOldBrush;
  BOOL Asymptote;
  SIZE oldSize;
  double gx, gy;
  int wx;
  int lcv;
  double dSonarWidth, dTickSize;
  int SonarWidth, TickSize;

  // Initialize Variables
  ClientRect.right = ClientRect.right - 1;
  ClientRect.bottom = ClientRect.bottom - 1;
  Orgin.x = MulDiv(1, ClientRect.right, 2);
  Orgin.y = MulDiv(1, ClientRect.bottom, 2);
  dSonarWidth = ((ClientRect.right * ClientRect.bottom) * (g->Modifier[M_SONARWIDTH] / 100));
  dTickSize = ((ClientRect.right * ClientRect.bottom) * (g->Modifier[M_TICKSIZE] / 100));
  if (dSonarWidth <= 0)
	 SonarWidth = 0;
  else
	 SonarWidth = (int) sqrt(dSonarWidth);
  if (dTickSize <= 0)
	 TickSize = 0;
  else
	 TickSize = (int) sqrt(dTickSize);
  NextPlot = 0;

  // Set viewport and background color
  OldBkColor = SetBkColor(hDC, g->Color[BACKGROUND]);
  SetViewportExtEx(hDC, ClientRect.right, ClientRect.bottom, &oldSize);

  // Paint the Background
  hBrush = CreateSolidBrush(gp.Color[BACKGROUND]);
  hPen = CreatePen(PS_SOLID, 1, gp.Color[BACKGROUND]);
  hOldBrush = SelectObject(hDC, hBrush);
  hOldPen = SelectObject(hDC, hPen);
  Rectangle(hDC, ClientRect.left, ClientRect.top, ClientRect.right + 1,
				ClientRect.bottom + 1);
  SelectObject(hDC, hOldBrush);
  SelectObject(hDC, hOldPen);
  DeleteObject(hPen);
  DeleteObject(hBrush);

  // Calculate ClientPlots Array
  wx = 0 - 1;
  for(lcv = 16; lcv >= 0; lcv--)
  {
	 gx = 0 - Plots[lcv];
	 wx = wx + 1;

	 ClientPlots[wx] = GraphXToClient(gx, ClientRect.right);
  }
  for(lcv = 1; lcv <= 16; lcv++)
  {
	 gx = Plots[lcv];
	 wx = wx + 1;

	 ClientPlots[wx] = GraphXToClient(gx, ClientRect.right);
  }

  if (g->Grid)
  {
	 // Draw Grid Lines
	 hPen = CreatePen(PS_DOT, 1, g->Color[GRID]);
	 hOldPen = SelectObject(hDC, hPen);

	 // Vertical

	 for(lcv = 0; lcv <= 15; lcv++)
	 {
		MoveToEx(hDC, ClientPlots[lcv], 0, NULL);
		LineTo(hDC, ClientPlots[lcv], ClientRect.bottom);
	 }
	 for(lcv = 17; lcv <= 32; lcv++)
	 {
		MoveToEx(hDC, ClientPlots[lcv], 0, NULL);
		LineTo(hDC, ClientPlots[lcv], ClientRect.bottom);
	 }

	 // Horizontal
	 for (wx = 0; wx <= 2; wx++)
	 {
		MoveToEx(hDC, 0, MulDiv(wx, ClientRect.bottom, 6), NULL);
		LineTo(hDC, ClientRect.right, MulDiv(wx, ClientRect.bottom, 6));
	 }
	 for (wx = 6; wx >= 4 ; wx--)
	 {
		MoveToEx(hDC, 0, MulDiv(wx, ClientRect.bottom, 6), NULL);
		LineTo(hDC, ClientRect.right, MulDiv(wx, ClientRect.bottom, 6));
	 }
	 SelectObject(hDC, hOldPen);
	 DeleteObject(hPen);
  }

  // Draw X and Y Axis
  hPen = CreatePen(PS_SOLID, 1, g->Color[AXIS]);
  hOldPen = SelectObject(hDC, hPen);
  MoveToEx(hDC, Orgin.x, ClientRect.left, NULL);
  LineTo(hDC, Orgin.x, ClientRect.bottom);
  MoveToEx(hDC, ClientRect.top, Orgin.y, NULL);
  LineTo(hDC, ClientRect.right, Orgin.y);
  SelectObject(hDC, hOldPen);
  DeleteObject(hPen);

  // Draw hash marks
  hPen = CreatePen(PS_SOLID, 1, g->Color[TICK]);
  hOldPen = SelectObject(hDC, hPen);
  for (wx = 0; wx <= 2; wx++)
  {
	 MoveToEx(hDC, Orgin.x - MulDiv(1, TickSize, 2), MulDiv(wx, ClientRect.bottom, 6), NULL);
	 LineTo(hDC, Orgin.x + MulDiv(1, TickSize, 2) + 1, MulDiv(wx, ClientRect.bottom, 6));
  }
  for (wx = 6; wx >= 4 ; wx--)
  {
	 MoveToEx(hDC, Orgin.x - MulDiv(1, TickSize, 2), MulDiv(wx, ClientRect.bottom, 6), NULL);
	 LineTo(hDC, Orgin.x + MulDiv(1, TickSize, 2) + 1, MulDiv(wx, ClientRect.bottom, 6));
  }
  MoveToEx(hDC, 0, Orgin.y - MulDiv(1, TickSize, 2), NULL);
  LineTo(hDC, 0, Orgin.y + MulDiv(1, TickSize, 2) + 1);
  MoveToEx(hDC, ClientRect.right, Orgin.y - MulDiv(1, TickSize, 2), NULL);
  LineTo(hDC, ClientRect.right, Orgin.y + MulDiv(1, TickSize, 2) + 1);
  SelectObject(hDC, hOldPen);
  DeleteObject(hPen);

  // Draw Graph
  if (g->Connect == CM_GRAPHDOTS)
  {
	 // Graph Dots
	 for(lcv = 0; lcv <= ClientRect.right; lcv++)
	 {
		gx = ClientToGraphX(lcv, ClientRect.right);

		if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
		  SetPixelV(hDC, lcv, GraphYToClient(gy, ClientRect.bottom), g->Color[CONNECT]);
	 }
  }
  if (g->Connect == CM_GRAPHBOTH)
  {
	 // Graph Dots and Lines
	 BOOL CurAsyn;
	 hPen = CreatePen(PS_SOLID, 1, g->Color[CONNECT]);
	 hOldPen = SelectObject(hDC, hPen);
	 gy = 0;
	 gx = GetX(0, ClientPlots, ClientRect.right);

	 if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
	 {
		Asymptote = FALSE;
		MoveToEx(hDC, 0, GraphYToClient(gy, ClientRect.bottom), NULL);
	 }
	 else
		Asymptote = TRUE;

	 for(lcv = 1; lcv <= ClientRect.right; lcv++)
	 {
		gx = GetX(lcv, ClientPlots, ClientRect.right);

		CurAsyn = GetTrigValue(gx, &gy, g->Graph, g->Modifier);
		if (CurAsyn && Asymptote)
		{
		  MoveToEx(hDC, lcv, GraphYToClient(gy, ClientRect.bottom), NULL);
		  Asymptote = FALSE;
		}
		if (CurAsyn && !Asymptote)
		  LineTo(hDC, lcv, GraphYToClient(gy, ClientRect.bottom));
		if (!CurAsyn)
		  Asymptote = TRUE;
	 }
	 SelectObject(hDC, hOldPen);
	 DeleteObject(hPen);
  }

  // Plot Points
  hPen = CreatePen(PS_SOLID, 1, g->Color[SONAR]);
  hOldPen = SelectObject(hDC, hPen);
  for(lcv = 16; lcv >= 0; lcv--)
  {
	 gx = 0 - Plots[lcv];

	 if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
	 {
		SetPixelV(hDC, GraphXToClient(gx, ClientRect.right), GraphYToClient(gy, ClientRect.bottom), g->Color[DOT]);
		if (g->Sonar)
		{
		  MoveToEx(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2), NULL);
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2));
		}
	 }
	 else
		DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g->Color[ASYMPTOTE], g->Color[AXIS]);
  }
  for(lcv = 1; lcv <= 16; lcv++)
  {
	 gx = Plots[lcv];

	 if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
	 {
		SetPixelV(hDC, GraphXToClient(gx, ClientRect.right), GraphYToClient(gy, ClientRect.bottom), g->Color[DOT]);
		if (g->Sonar)
		{
		  MoveToEx(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2), NULL);
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom) - MulDiv(1, SonarWidth, 2));
		}
	 }
	 else
		DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g->Color[ASYMPTOTE], g->Color[AXIS]);
  }
  SelectObject(hDC, hOldPen);
  DeleteObject(hPen);

  // Set viewport to original settings
  SetViewportExtEx(hDC, oldSize.cx, oldSize.cy, NULL);
  SetBkColor(hDC, OldBkColor);
}

int GraphXToClient(double GraphPoint, int ClientWidth, GridProperties *g)
{
  return StrangeRound((((GraphPoint + 2 * M_PI) * ClientWidth) / (4 * M_PI)), 6);
}

int GraphYToClient(double GraphPoint, int ClientHeight, GridProperties *g)
{
  return StrangeRound((((6 - (GraphPoint + 3)) * ClientHeight) / 6), 6);
}

double ClientToGraphX(int GraphPoint, int ClientWidth, GridProperties *g)
{
  return (((4 * M_PI) * GraphPoint) / (ClientWidth)) - (2 * M_PI);
}

double ClientToGraphY(int GraphPoint, int ClientHeight, GridProperties *g)
{
  return 6 - (((6 * GraphPoint) / (ClientHeight)));
}

/*	 nTicks = StrangeRound((g->Modifier[M_XMAX] - g->Modifier[M_XMIN]) / g->Modifier[M_XTICK], DEC);
	 for (lcv = 0; lcv <= nTicks; lcv++)
	 {
		gx = GraphXToClient(g->Modifier[M_XMIN] + lcv * g->Modifier[M_XTICK], ClientRect.right, g);
		MoveToEx(hDC, gx, 0, NULL);
		LineTo(hDC, gx, ClientRect.bottom);
	 }*/
/*	 nTicks = StrangeRound((g->Modifier[M_YMAX] - g->Modifier[M_YMIN]) / g->Modifier[M_YTICK], DEC);
	 for (lcv = 0; lcv <= nTicks; lcv++)
	 {
		gy = GraphYToClient(g->Modifier[M_YMIN] + lcv * g->Modifier[M_YTICK], ClientRect.bottom, g);
		MoveToEx(hDC, 0, gy, NULL);
		LineTo(hDC, ClientRect.right, gy);
	 }*/

  // Horizontal
  nTicks = StrangeRound((g->Modifier[M_XMAX] - g->Modifier[M_XMIN]) / g->Modifier[M_XTICK], DEC);
  for (lcv = 0; lcv <= nTicks; lcv++)
  {
	 gx = GraphXToClient(g->Modifier[M_XMIN] + lcv * g->Modifier[M_XTICK], ClientRect.right, g);
	 MoveToEx(hDC, gx, Orgin.y - MulDiv(1, TickSize, 2), NULL);
	 LineTo(hDC, gx, Orgin.y + MulDiv(1, TickSize, 2) + 1);
  }
  // Vertical
  nTicks = StrangeRound((g->Modifier[M_YMAX] - g->Modifier[M_YMIN]) / g->Modifier[M_YTICK], DEC);
  for (lcv = 0; lcv <= nTicks; lcv++)
  {
	 gy = GraphYToClient(g->Modifier[M_YMIN] + lcv * g->Modifier[M_YTICK], ClientRect.bottom, g);
	 MoveToEx(hDC, Orgin.x - MulDiv(1, TickSize, 2), gy, NULL);
	 LineTo(hDC, Orgin.x + MulDiv(1, TickSize, 2) + 1, gy);
  }

  /*  nTicks = StrangeRound((g->Modifier[M_XMAX] - g->Modifier[M_XMIN]) / g->Modifier[M_XTICK], DEC);
  for (lcv = 0; lcv <= nTicks; lcv++)
  {
	 gx = g->Modifier[M_XMIN] + lcv * g->Modifier[M_XTICK];

	 if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
	 {
		SetPixelV(hDC, GraphXToClient(gx, ClientRect.right, g), GraphYToClient(gy, ClientRect.bottom, g), g->Color[DOT]);
		if (g->Sonar)
		{
		  MoveToEx(hDC, GraphXToClient(gx, ClientRect.right, g) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom, g) - MulDiv(1, SonarWidth, 2), NULL);
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right, g) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom, g) - MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right, g) + MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom, g) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right, g) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom, g) + MulDiv(1, SonarWidth, 2));
		  LineTo(hDC, GraphXToClient(gx, ClientRect.right, g) - MulDiv(1, SonarWidth, 2), GraphYToClient(gy, ClientRect.bottom, g) - MulDiv(1, SonarWidth, 2));
		}
	 }
	 else
		DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g);
  }*/
		gx = GraphXToClient(lcv * g->Modifier[M_XTICK], ClientRect.right, g);
		MoveToEx(hDC, gx, 0, NULL);
		LineTo(hDC, gx, ClientRect.bottom);
		lcv++;
	 }
	 lcv = -1;
	 while (lcv * g->Modifier[M_XTICK] >= g->Modifier[M_XMIN])
	 {
		gx = GraphXToClient(lcv * g->Modifier[M_XTICK], ClientRect.right, g);
		MoveToEx(hDC, gx, 0, NULL);
		LineTo(hDC, gx, ClientRect.bottom);
		lcv--;
	 }

	 if (GetTrigValue(gx, &gy, g->Graph, g->Modifier))
	 {
		Asymptote = FALSE;
		MoveToEx(hDC, 0, GraphYToClient(gy, ClientRect.bottom, g), NULL);
		prev = gy;
	 }
	 else
	 {
		Asymptote = TRUE;
		DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g);
	 }

	 for(lcv = 1; lcv <= ClientRect.right; lcv++)
	 {
		gx = ClientToGraphX(lcv, ClientRect.right, g);

		CurAsyn = GetTrigValue(gx, &gy, g->Graph, g->Modifier);
		if ((((prev > 1000) && (gy < 1000)) || ((prev < 1000) && (gy > 1000))) || !CurAsyn)
		{
		  // Asymptote Time!!
		  CurAsyn = FALSE;
		  DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g);
		  gy = 0;
		}
		if (CurAsyn && Asymptote)
		{
		  MoveToEx(hDC, lcv, GraphYToClient(gy, ClientRect.bottom, g), NULL);
		  Asymptote = FALSE;
		}
		if (CurAsyn && !Asymptote)
		  LineTo(hDC, lcv, GraphYToClient(gy, ClientRect.bottom, g));
		if (!CurAsyn)
		  Asymptote = TRUE;
		prev = gy;
	 }
/*int StrangeRound(double x, int p)
{
  int lcv;

  // This function does a strange round; when given a number and a number
  // of decimal places, StrangeRound starts from the specified decimal spot
  // and rounds until it derives an integer.  In other words, it rounds to
  // the specified number of decimal places and loops until an integer is
  // derived, rounding to the previous decimal place through each pass of
  // the loop until a decimal point is reached.  For example, the number
  // 4.44444444521, when rounded with 8 decimal places, would produce 5.
  for(lcv = p; lcv >= 1; lcv--)
  {
	 if ((((x * pow(10, lcv - 1) - floor(x * pow(10, lcv - 1))) * 10) >= 5) &&
		 (((x * pow(10, lcv - 1) - floor(x * pow(10, lcv - 1)))) < 9))
		x = x + pow(10, 0 - (lcv - 1));
  }
  return (int) x;
}*/


//		  LPBITMAPINFO lpBitmapInfo;
//		  int lcv;

/*		  lpBitmapInfo = (LPBITMAPINFO) LocalAlloc(LPTR, sizeof(BITMAPINFOHEADER) + sizeof(DWORD) * 3 + sizeof(RGBQUAD) * (TICK + 1));
		  for (lcv = ASYMPTOTE; lcv <= TICK; lcv++)
		  {
			 lpBitmapInfo->bmiColors[lcv].rgbRed = GetRValue(gp.Color[lcv]);
			 lpBitmapInfo->bmiColors[lcv].rgbGreen = GetGValue(gp.Color[lcv]);
			 lpBitmapInfo->bmiColors[lcv].rgbBlue = GetBValue(gp.Color[lcv]);
			 lpBitmapInfo->bmiColors[lcv].rgbReserved = 0;
		  }
		  lpBitmapInfo->bmiHeader.biClrUsed = TICK + 1;
//		  WinGRecommendDIBFormat(lpBitmapInfo);
		  lpBitmapInfo->bmiHeader.biHeight = ClientRect.bottom;
		  lpBitmapInfo->bmiHeader.biWidth = ClientRect.right;
		  if ((hGraph = WinGCreateBitmap(memDC, lpBitmapInfo, 0)) == 0)
		  {
			 // Error, bitmap could not be created!
			 DeleteDC(memDC);
			 LocalFree(LocalHandle(lpBitmapInfo));
			 ReleaseDC(hWnd, hDC);
			 ValidateRect(hWnd, NULL);
			 return 0;
		  }
		  LocalFree(LocalHandle(lpBitmapInfo));*/


/*double GetX(int x, int *ClientPlots, int ClientWidth)
{
  if (NextPlot > 32)
	 return ClientToGraphX(x, ClientWidth);
  if (ClientPlots[NextPlot] == x)
  {
	 NextPlot++;
	 if (NextPlot - 1 >= 16)
		return Plots[(NextPlot - 1) - 16];
	 else
		return 0 - Plots[16 - (NextPlot - 1)];
  }
  return ClientToGraphX(x, ClientWidth);
}*/


//	 else
//		DrawAsymptote(hDC, gx, ClientRect.right, ClientRect.bottom, Orgin.x, g);

