// Tester for the Trig Values

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include "trigfunc.h"

BOOL GetTrigValue(double x, double *y, int Method);
double round(double x, int p);

void main(void)
{
  double P2;
  double P3;
  double P4;
  double P6;
  double Plots [17];
  double Value;
  int lcv;

  // Initialize PI values
  P2 = M_PI / 2;
  P3 = M_PI / 3;
  P4 = M_PI / 4;
  P6 = M_PI / 6;

  // Initialize Plots array
  Plots[0] = 0;
  Plots[1] = P6;
  Plots[2] = P4;
  Plots[3] = P3;
  Plots[4] = P2;
  Plots[5] = 2 * P3;
  Plots[6] = 3 * P4;
  Plots[7] = 5 * P6;
  Plots[8] = M_PI;
  Plots[9] = 7 * P6;
  Plots[10] = 5 * P4;
  Plots[11] = 4 * P3;
  Plots[12] = 3 * P2;
  Plots[13] = 5 * P3;
  Plots[14] = 7 * P4;
  Plots[15] = 11 * P6;
  Plots[16] = 2 * M_PI;

  // Print the values of them
  for(lcv = 0; lcv <= 16; lcv++)
  {
	 printf("Plots[%i]   = %.12lf\n", lcv, Plots[lcv]);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHSINE))
		printf("  Sine      = %.12lf\n", Value);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHCOSINE))
		printf("  Cosine    = %.12lf\n", Value);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHTANGENT))
		printf("  Tangent   = %.12lf\n", Value);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHCOTANGENT))
		printf("  Cotangent = %.12lf\n", Value);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHSECANT))
		printf("  Secant    = %.12lf\n", Value);
	 if (GetTrigValue(Plots[lcv], &Value, CM_GRAPHCOSECANT))
		printf("  Cosecant  = %.12lf\n", Value);
	 while(!kbhit());
	 getch();
  }
  printf("\n\nDone.");
  while(!kbhit());
  getch();
}

BOOL GetTrigValue(double x, double *y, int Method)
{
  double sx = sin(x);
  double cx = cos(x);

  *y = 0;
  switch (Method)
  {
	 case CM_GRAPHSINE      : { *y = sx; break; }
	 case CM_GRAPHCOSINE    : { *y = cx; break; }
	 case CM_GRAPHTANGENT   : { if (round(cx, 6) == 0) return FALSE; *y = sx / cx; break; }
	 case CM_GRAPHCOTANGENT : { if (round(sx, 6) == 0) return FALSE; *y = cx / sx; break; }
	 case CM_GRAPHSECANT    : { if (round(cx, 6) == 0) return FALSE; *y = 1 / cx; break; }
	 case CM_GRAPHCOSECANT  : { if (round(sx, 6) == 0) return FALSE; *y = 1 / sx; break; }
  }

  return TRUE;
}

double round(double x, int p)
{
  x = x * pow(10, p);
  if (x - floor(x) >= .5)
	 x = x + 1;
  return floor(x) / pow(10, p);
}
